// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GDKMM_DISPLAYMANAGER_H
#define _GDKMM_DISPLAYMANAGER_H

#include <glibmm.h>

/* $Id: displaymanager.hg,v 1.3 2003/01/05 16:10:34 murrayc Exp $ */

/* displaymanager.h
 *
 * Copyright (C) 2002 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/object.h>
#include <gdkmm/display.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GdkDisplayManager GdkDisplayManager;
typedef struct _GdkDisplayManagerClass GdkDisplayManagerClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gdk
{ class DisplayManager_Class; } // namespace Gdk
namespace Gdk
{


class DisplayManager : public Glib::Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef DisplayManager CppObjectType;
  typedef DisplayManager_Class CppClassType;
  typedef GdkDisplayManager BaseObjectType;
  typedef GdkDisplayManagerClass BaseClassType;

private:
  friend class DisplayManager_Class;
  static CppClassType displaymanager_class_;

  // noncopyable
  DisplayManager(const DisplayManager&);
  DisplayManager& operator=(const DisplayManager&);

protected:
  explicit DisplayManager(const Glib::ConstructParams& construct_params);
  explicit DisplayManager(GdkDisplayManager* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~DisplayManager();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  GdkDisplayManager*       gobj()       { return reinterpret_cast<GdkDisplayManager*>(gobject_); }
  const GdkDisplayManager* gobj() const { return reinterpret_cast<GdkDisplayManager*>(gobject_); }

  GdkDisplayManager* gobj_copy();

private:

protected:

public:

  
  /** 
   * @return The singleton Gdk::DisplayManager object.
   * the global Gdk::DisplayManager singleton; gdk_parse_pargs(),
   * gdk_init(), or gdk_init_check() must have been called first.
   * 
   * Since: 2.2.
   */
  static Glib::RefPtr<DisplayManager> get();
  
  /** Gets the default Gdk::Display.
   * @return A Gdk::Display, or <tt>0</tt> if there is no default
   * display.
   * 
   * Since: 2.2.
   */
  Glib::RefPtr<Display> get_default_display();
  
  /** Gets the default Gdk::Display.
   * @return A Gdk::Display, or <tt>0</tt> if there is no default
   * display.
   * 
   * Since: 2.2.
   */
  Glib::RefPtr<const Display> get_default_display() const;

  
  /** Sets @a display  as the default display.
   * 
   * Since: 2.2
   * @param display A Gdk::Display.
   */
  void set_default_display(const Glib::RefPtr<Display>& display);

  
  /** List all currently open displays.
   * @return A newly allocated G::SList of Gdk::Display objects.
   * Free this list with Glib::slist_free() when you are done with it.
   * 
   * Since: 2.2.
   */
  Glib::SListHandle< Glib::RefPtr<Display> > list_displays();


  Glib::PropertyProxy< Glib::RefPtr<Display> > property_default_display();

  
  /**
   * @par Prototype:
   * <tt>void %display_opened(const Glib::RefPtr<Display>& display)</tt>
   */
  Glib::SignalProxy1<void,const Glib::RefPtr<Display>&> signal_display_opened();


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_display_opened(const Glib::RefPtr<Display>& display);


};

} /* namespace Gdk */


namespace Glib
{
  /** @relates Gdk::DisplayManager */
  Glib::RefPtr<Gdk::DisplayManager> wrap(GdkDisplayManager* object, bool take_copy = false);
}


#endif /* _GDKMM_DISPLAYMANAGER_H */

