// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GDKMM_PIXMAP_H
#define _GDKMM_PIXMAP_H

#include <glibmm.h>

/* $Id: pixmap.hg,v 1.27 2002/12/29 00:43:08 murrayc Exp $ */

/* Copyright (C) 1998-2002 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gdkmm/drawable.h>
#include <gdkmm/color.h>
#include <gdkmm/colormap.h>
#include <gdkmm/types.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
extern "C" {
//Custom stuct prototypes, because they aren't what the code-generator expects:
typedef struct _GdkDrawable GdkPixmap;
typedef struct _GdkPixmapClass GdkPixmapClass;
} // extern "C"
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


#ifndef DOXYGEN_SHOULD_SKIP_THIS
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gdk
{ class Pixmap_Class; } // namespace Gdk
namespace Gdk
{

class Window;


class Pixmap : public Gdk::Drawable
{
  // GdkPixmap is a typedef to GdkDrawable, but it's actually a GdkPixmapObject.
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Pixmap CppObjectType;
  typedef Pixmap_Class CppClassType;
  typedef GdkPixmap BaseObjectType;
  typedef GdkPixmapObjectClass BaseClassType;

private:
  friend class Pixmap_Class;
  static CppClassType pixmap_class_;

  // noncopyable
  Pixmap(const Pixmap&);
  Pixmap& operator=(const Pixmap&);

protected:
  explicit Pixmap(const Glib::ConstructParams& construct_params);
  explicit Pixmap(GdkPixmap* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Pixmap();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  GdkPixmap*       gobj()       { return reinterpret_cast<GdkPixmap*>(gobject_); }
  const GdkPixmap* gobj() const { return reinterpret_cast<GdkPixmap*>(gobject_); }

  GdkPixmap* gobj_copy();

private:

   // see wrap_new() implementation in pixmap.ccg
  

protected:
  Pixmap();

  // TODO: should take a Glib::RefPtr<Gdk::Drawable> instead.
  Pixmap(const Glib::RefPtr<Window>& window, int width, int height, int depth = -1);

  // TODO: should take a Glib::RefPtr<Gdk::Drawable> instead.
  /// Initialize a Pixmap from data.
  Pixmap(const Glib::RefPtr<Window>& window,
         const char* data, int width, int height, int depth,
         const Color& fg, const Color& bg);

  Pixmap(const Glib::RefPtr<Display>& display, GdkNativeWindow anid);

public:
  
  static Glib::RefPtr<Pixmap> create();
 // TODO: remove, doesn't work - there's no underlying GDK equivalent.

  // TODO: should take a Glib::RefPtr<Gdk::Drawable> instead.
  
  static Glib::RefPtr<Pixmap> create(const Glib::RefPtr<Window>& window, int width, int height, int depth);

  
  static Glib::RefPtr<Pixmap> create(const Glib::RefPtr<Window>& window, const char* data, int width, int height, int depth, const Color& fg, const Color& bg);


  static Glib::RefPtr<Pixmap> create(const Glib::RefPtr<Display>& display, GdkNativeWindow anid);
;
  
  
  static Glib::RefPtr<Pixmap> create_from_data(const Glib::RefPtr<const Drawable>& drawable,
                                               const char* data, int width, int height, int depth,
                                               const Color& fg, const Color& bg);

  /// Create a Pixmap from a xpm file.
  static Glib::RefPtr<Pixmap> create_from_xpm(const Glib::RefPtr<const Drawable>& drawable,
                                              const Color& transparent_color,
                                              const std::string& filename);

  // Create a Pixmap from a xpm file.
  static Glib::RefPtr<Pixmap> create_from_xpm(const Glib::RefPtr<const Drawable>& drawable,
                                              Glib::RefPtr<Bitmap>& mask,
                                              const Color& transparent_color,
                                              const std::string& filename);

  /// Create a Pixmap from a xpm file with colormap.
  static Glib::RefPtr<Pixmap> create_from_xpm(const Glib::RefPtr<const Drawable>& drawable,
                                              const Glib::RefPtr<Colormap>& colormap,
                                              Glib::RefPtr<Bitmap>& mask,
                                              const Color& transparent_color,
                                              const std::string& filename);

  static Glib::RefPtr<Pixmap> create_from_xpm(const Glib::RefPtr<const Drawable>& drawable,
                                              Glib::RefPtr<Bitmap>& mask,
                                              const Color& transparent_color,
                                              const char* const* data);

  static Glib::RefPtr<Pixmap> create_from_xpm(const Glib::RefPtr<const Drawable>& drawable,
                                              const Glib::RefPtr<Colormap>& colormap,
                                              Glib::RefPtr<Bitmap>& mask,
                                              const Color& transparent_color,
                                              const char* const* data);

  static Glib::RefPtr<Pixmap> create_from_xpm(const Glib::RefPtr<Colormap>& colormap,
                                              Glib::RefPtr<Bitmap>& mask,
                                              const Color& transparent_color,
                                              const char* const* data);

  static Glib::RefPtr<Pixmap> create_from_xpm(const Glib::RefPtr<Colormap>& colormap,
                                              Glib::RefPtr<Bitmap>& mask,
                                              const char* const* data);


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Gdk


namespace Glib
{
  /** @relates Gdk::Pixmap */
  Glib::RefPtr<Gdk::Pixmap> wrap(GdkPixmapObject* object, bool take_copy = false);
}


#endif /* _GDKMM_PIXMAP_H */

